=== debian/changelog ===
openms (2.0.0-4build3) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:34:46 +0000

openms (2.0.0-4build2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:27:48 +0000

openms (2.0.0-4build1) yakkety; urgency=medium

  * No-change rebuild against glpk 4.60

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 25 May 2016 11:59:34 +0200

openms (2.0.0-4) unstable; urgency=medium

  * debian/control: Change "Conflicts:" to "Breaks:" (Closes:
    #816562);

  * debian/rules: fix the OPENMS_DATA_PATH value so that it points to
    /us/share/openms-common and not /usr/share/openms-common/OpenMS.

  * debian/rules: Put dh_clean at the end of the clean target.

  * switched doc_minimal doc_class_only targets around in the make call
    because the doxygen-based documentation for the classes did not get
    generated fully.

  * Remove the git protocol URL for the repos and switch to secure http for
    the other URL.

  * debian/control: Standards-Version: 3.9.7. No changes required.

  * debian/rules: Reinstate DEB_BUILD_MAINT_OPTIONS along with the hardening
    flag +all..

  * debian/rules: Make sure libSuperHirn and libOpenMS_GUI libraries are
    processed fine with respect to the symbols control file.
 
 -- Filippo Rusconi <lopippo@debian.org>  Wed, 30 Mar 2016 12:06:31 +0200

openms (2.0.0-3) unstable; urgency=medium

  * Ship the dynamically generated cmake files to the -dev package.

  * Improve the build system patch to state that we prefer libboost shared
    objects.

  * debian/rules: Packaging (debian/*.install files) now uses the material
    that has been installed with make install DESTDIR=debian/build after
    cmake call with -DCMAKE_INSTALL_PREFIX=/usr.
    
 -- Filippo Rusconi <lopippo@debian.org>  Mon, 18 Jan 2016 21:35:18 +0100

openms (2.0.0-2) unstable; urgency=medium

  * Ship the code examples to the openms-doc package. These examples are
    partially described in the documentation (html format) but having the
    whole code files is more interesting.

  * d/control: add "Replaces: libopenms-1.11" to fix upgrade problem
    (Closes: #810356), thanks to Andreas Beckmann <anbe@debian.org> for
    the report.

  * Bump-up debian/compat to 9.

  * debian/watch: use sf redirector.
    
 -- Filippo Rusconi <lopippo@debian.org>  Thu, 14 Jan 2016 12:36:43 +0100

openms (2.0.0-1) unstable; urgency=medium

  * New upstream version (Closes: #790624 ; Closes: #804496).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 17 Aug 2015 17:17:37 +0200

openms (1.11.1-5) unstable; urgency=medium

  * mv upstream upstream/metadata

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 18 Aug 2014 11:48:52 +0200

openms (1.11.1-4) unstable; urgency=low

  * Apply a patch suggested by Stephan Aiche <Stephan.Aiche@fu-berlin.de>
    to fix the failure when buiding the manuals using the LaTeX code
    created by Doxygen.
  
  * Create debian/missing-sources/jquery-1.7.1.js with the source file
    from http://code.jquery.com/jquery-1.7.1.js (lintian warning).
  
  * Add #DEBHELPER# to postinst (lintian warning).
  
  * Fix syntax error in the copyright file (lintian warning).
  
  * Remove ${shlibs:Depends} from Depends: of -common and -doc.
  
  * debian/copyright: fix syntax of the copyright field of the Files: *
    section.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 30 Jun 2014 09:46:50 +0200
